;; Converts all texts in the drawing to uppercase.
(defun C:UPCASE_ALL (/ OR_OPEN OR_CLOSE filter ss tent telem tcontent telemupper n)
  
  ; retrieve the selection set containing both
  ; single and multiline text objects
  (setq OR_OPEN '(-4 . "<OR")		; this could be useful in larger
	OR_CLOSE '(-4 . "OR>")		; applications
    	filter (list OR_OPEN '(0 . "TEXT") '(0 . "MTEXT") OR_CLOSE)
  	ss (ssget "X" filter)
	)

  ; iterate over the selection set
  (setq n 0)
  (repeat (sslength ss)
    (setq
      	  ; retrieve the text entity from the ss
    	  tent 		(entget (ssname ss n))
	  ; retrieve the text group
	  telem 	(assoc 1 tent)
	  ; the actual text content is the cdr
	  tcontent 	(cdr telem)
	  ; make the content uppercase
	  tcontent	(strcase tcontent)
	  ; construct the new (dotted pair) element
	  telemupper	(cons 1 tcontent)
	  ; change the entity
	  tent		(subst telemupper telem tent)
	  )
    (entmod tent)	; update the entity definition
    (setq n (1+ n))	; next
    )

(princ)
)

